package pagerank;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

public class MatrixMuti {

	private static Integer abjMatrix[][] = null;
	private static Double transMatrix[][] = null;

	public void readFile(String file) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(file));
			Map<String, String[]> matrix = new HashMap<String, String[]>();
			String line;
			while ((line = in.readLine()) != null) {
				String p = line.split("\\s+")[0];
				String po[] = line.split("\\s+")[1].split(",");
				matrix.put(p, po);
			}
			@SuppressWarnings("unchecked")
			Map.Entry<String, String[]>[] entries = Comm.getSortedHashtableByValue(matrix, new Comparator<Map.Entry<String, ?>>() {
				@Override
				public int compare(final Entry<String, ?> o1, final Entry<String, ?> o2) {
					// TODO Auto-generated method stub
					return o1.getKey().compareTo(o2.getKey());
				}
			});

			Map<String, Integer> seqNum = new HashMap<String, Integer>();
			Integer count = 0;
			for (Entry<String, ?> entry : entries) {
				seqNum.put(entry.getKey(), count++);
			}
			abjMatrix = new Integer[entries.length][entries.length];
			transMatrix = new Double[entries.length][entries.length];
			for (int i = 0; i < abjMatrix.length; i++) {
				for (int j = 0; j < abjMatrix[i].length; j++) {
					abjMatrix[i][j] = 0;
					transMatrix[i][j] = (1 - Comm.damp) / entries.length;
				}
			}
			for (Entry<String, String[]> entry : entries) {
				int i = seqNum.get(entry.getKey());
				String po[] = entry.getValue();
				for (String out : po) {
					abjMatrix[i][seqNum.get(out)] = 1;
				}
			}
			
			printMatrix(transMatrix);
			for (int i = 0; i < transMatrix.length; i++) {
				Integer[] as = abjMatrix[i];
				Integer s = 0;
				for (Integer k : as) {
					s += k;
				}
				
				for (int j = 0; j < transMatrix[i].length; j++) {
					transMatrix[i][j] += Comm.damp * abjMatrix[i][j] / (double) s;
				}
			}
			printMatrix(transMatrix);
			printMatrix(abjMatrix);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private <T> void printMatrix(T[][] matrix) {
		for (T[] ts : matrix) {
			System.out.println(Arrays.toString(ts));
		}
	}

	private Double[][] transposMatrix(Double[][] data) {
		Double[][] resMatrix = new Double[data.length][data[0].length];

		for (int i = 0; i < data.length; i++) {
			for (int j = 0; j < data[0].length; j++) {
				resMatrix[j][i] = data[i][j];
			}
		}
		return resMatrix;
	}

	private Double multiArray(Double[] d1, Double[] d2) {
		int len = d1.length < d2.length ? d1.length : d2.length;
		Double res = 0.0;
		for (int i = 0; i < len; i++) {
			res += d1[i] * d2[i];
		}
		return res;
	}

	private Double[] matrixMultiply(Double[] t, Double[][] matrix) {
		Double[][] tm = transposMatrix(matrix);
		Double[] res = new Double[t.length];
		for (int i = 0; i < res.length; i++) {
			res[i] = multiArray(t, tm[i]);
		}
		return res;
	}

	public void run(String file) {
		readFile(file);
		Double res[] = new Double[abjMatrix.length];
		for (int i = 0; i < res.length; i++) {
			res[i] = 1.0;
		}
		for (int i = 0; i < 100; i++) {
			res = matrixMultiply(res, transMatrix);
			 System.out.println(Arrays.toString(res));
		}
		System.out.println(Arrays.toString(Comm.normMatrix(res)));
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		MatrixMuti muti = new MatrixMuti();
		String rootPath = ClassLoader.getSystemResource("pagerank").getPath();
		muti.run(rootPath + "/page.in");
	}

}
